BEGIN{
# Note.
# Assets - Liabilities = Equity + (Income - Expenses)
#
# User Configuration START

	transaction_file 	= "personal.trn";
	accounts_file 		= "personal.acc";
	
	FREC 	= 1; 
	FDATE 	= 2; 
	FDEBIT 	= 3; 
	FCREDIT	= 4; 
	FVALUE 	= 5;
        FPRC	= 6;
        FXCHG	= 7;
	FDESC	= 9;

	FACCNUMBER 	= 1;
	FACCNAME	= 2;
	FCURRENCY	= 4;
	FUNIT		= 5;
	FACCDESC	= 6;
	
	CUR_1 = "PHP"; CV_1 = 1;
	CUR_2 = "HKD"; CV_2 = 5.71;

# User Configuration END
	if ( ARGV[1] == "-h" ){
		print("usage: awk -f a.l [ options ] ");
		print("");
		print("Options:");
		print("awk -f a.l [command] [date] [memo] [debit] [credit] [value]");
		exit;
		}
	
	if( ARGV[1] == "split"){
		if( ARGC >= 6 )parse_split();	
		else print("usage: awk -f a.l split [date] [memo] [debit] [credit] [value] [[credit(2)] [value(2)] .. [credit(n)] [value(n)]]");
	}
	if( ARGV[1] == "new"){
		if( ARGC == 7 )parse_new();	
		else print("usage: awk -f a.l new [date] [memo] [debit] [credit] [value]");
	}
	if( ARGV[1] == "buy" ){
		if( ARGC == 12 )parse_bstocks();	
		else print("usage: awk -f a.l buy [date] [memo] [debit] [symbol] [shares] [price] [borker account] [broker fee] [tax account] [transaction tax]");
	}
	if( ARGV[1] == "sell" ){
		if( ARGC == 14 )parse_sstocks();	
		else print("usage: awk -f a.l sell [date] [memo] [symbol] [credit] [shares] [price] [borker account] [broker fee] [tax account] [transaction tax] [income] [symbol category]");
	}
	if( ARGV[1] == "bfund" ){
		if( ARGC == 10 )parse_bfund();	
		else print("usage: awk -f a.l bfund [date] [memo] [debit] [symbol] [shares] [price] [fund_account] [transaction fee]");
	}

}

function account_total_credit( _account ){
	_total_credit = "";
	_n = 0;
	while((getline < transaction_file)){
		if( $(FCREDIT) == _account) {
			_n = _n + $(FPRC) * $(FVALUE);
			}
		}
	close( transaction_file);
	return _n;

}

function parse_sstocks(){
	date = ARGV[2];
	memo = ARGV[3];
	symbol = ARGV[4];
	credit = ARGV[5];
	uvalue = ARGV[6];
	uprice = ARGV[7];
	tax_account = ARGV[8];
	tax = ARGV[9];
	broker = ARGV[10];
	broker_fee = ARGV[11];
	income_account = ARGV[12];
	symbol_category = ARGV[13];
	xchg_sym = getaccount_curr( symbol );
	xchg_sym = getconv_value( xchg_sym );
       	xchg_c = getaccount_curr( credit );
        xchg_c = getconv_value( xchg_c );
       	xchg_tax = getaccount_curr( tax_account );
        xchg_tax = getconv_value( xchg_tax );
       	xchg_bfee = getaccount_curr( broker );
        xchg_bfee = getconv_value( xchg_bfee );
       	xchg_in = getaccount_curr( income_account );
        xchg_in = getconv_value( xchg_in );
       	xchg_scat = getaccount_curr( symbol_category );
        xchg_scat = getconv_value( symbol_category );

	xchg_credit_sym = xchg_c / xchg_sym;
	xchg_credit_tax = xchg_c / xchg_tax;
	xchg_credit_bfee = xchg_c / xchg_bfee;
	xchg_credit_income = xchg_c / xchg_in;
	xchg_credit_income = xchg_c / xchg_in;
	xchg_credit_scat = xchg_c / xchg_scat;

	xchg_income_sym = xchg_in / xchg_sym;
	average_price = ave_price(symbol);
	printf("\nDATE: %s %s\n", date, memo);
	printf("[*] %10s %-10s\t%10.3f %s\n", symbol, getaccount_name( symbol ), uvalue, "SHARE(S)"); 
	printf("[+] %10s %-10s\t%10.3f %s\n", credit, getaccount_name( credit ), uvalue * uprice * xchg_credit_sym, getaccount_curr( symbol)); 
	printf("[+] %10s %-10s\t%10.3f %s\n", tax_account, getaccount_name( tax_account ), ( tax * xchg_credit_tax ), getaccount_curr( tax_account)); 
	printf("[+] %10s %-10s\t%10.3f %s\n",  broker, getaccount_name( broker ), ( broker_fee * xchg_credit_bfee ), getaccount_curr( broker)); 
	printf("[+] %10s %-10s\t%10.3f %s\n",  income_account, getaccount_name( income_account ), ( uvalue * (uprice-average_price) * xchg_credit_income ), getaccount_curr( income_account)); 
	printf("[+] %10s %-10s\t%10.3f %s\n",  symbol_category, getaccount_name( symbol_category ), ( uvalue * (uprice-average_price) * xchg_credit_scat ), getaccount_curr( symbol_category)); 
	printf("Record transaction -> ");
	getline n < "-";
	if( n == "y" || n == "Y" ){
		rec = transaction_new( "", date, symbol, credit, uvalue, uprice, xchg_credit_sym, memo, transaction_file);
		transaction_new( rec, date, credit, tax_account, tax, 1, xchg_credit_tax, memo, transaction_file);
		transaction_new( rec, date, credit, broker, broker_fee, 1, xchg_credit_bfee, memo, transaction_file);
		transaction_new( rec, date, income_account, credit, uvalue * (uprice-average_price), 1, xchg_credit_income, memo, transaction_file);
		transaction_new( rec, date, credit, symbol_category, uvalue * (uprice-average_price), 1, xchg_income_sym, memo, transaction_file);

	}
}

function ave_price( _symbol ){
	_avep = "";
	_x = 0;
	_y = 0;
	_n = 0;
	while((getline < transaction_file)){
		if( $(FCREDIT) == _symbol) {
			_x = _x + $(FPRC);
			_y = _y + $(FVALUE);
			_n = _n + 1;
			}
		}
	if( _n > 0) _avep = _x / _n;
	close( transaction_file);
	return _avep;
}

function parse_bstocks(){
	date = ARGV[2];
	memo = ARGV[3];
	debit = ARGV[4];
	symbol = ARGV[5];
	uvalue = ARGV[6];
	uprice = ARGV[7];
	tax_account = ARGV[8];
	tax = ARGV[9];
	broker = ARGV[10];
	broker_fee = ARGV[11];
	xchg_d = getaccount_curr( debit );
	xchg_d = getconv_value( xchg_d );
       	xchg_sym = getaccount_curr( symbol );
        xchg_sym = getconv_value( xchg_sym );
       	xchg_tax = getaccount_curr( tax_account );
        xchg_tax = getconv_value( xchg_tax );
       	xchg_bfee = getaccount_curr( broker );
        xchg_bfee = getconv_value( xchg_bfee );
	xchg_debit_sym = xchg_sym / xchg_d;
	xchg_debit_tax = xchg_d / xchg_tax;
	xchg_debit_bfee = xchg_d / xchg_bfee;
	printf("\nDATE: %s %s\n", date, memo);
	printf("[*] %10s %-10s\t%10.3f %s %s\n", debit, getaccount_name( debit ), uvalue * uprice * xchg_debit_sym, getaccount_curr( debit), getaccount_desc( debit )); 
	printf("[+] %10s %-10s\t%10.3f %s\n", symbol, getaccount_name( symbol ), uvalue, "SHARE(S)"); 
	printf("[+] %10s %-10s\t%10.3f %s\n", tax_account, getaccount_name( tax_account ), ( tax * xchg_debit_tax ), getaccount_curr( tax_account)); 
	printf("[+] %10s %-10s\t%10.3f %s\n",  broker, getaccount_name( broker ), ( broker_fee * xchg_debit_bfee ), getaccount_curr( broker)); 
	printf("Record transaction -> ");
	getline n < "-";
	if( n == "y" || n == "Y" ){
		rec = transaction_new( "", date, debit, symbol, uvalue, uprice, xchg_debit_sym, memo, transaction_file);
		transaction_new( rec, date, debit, tax_account, tax, 1, xchg_debit_tax, memo, transaction_file);
		transaction_new( rec, date, debit, broker, broker_fee, 1, xchg_debit_bfee, memo, transaction_file);
	}
}

function parse_bfund(){
	date = ARGV[2];
	memo = ARGV[3];
	debit = ARGV[4];
	symbol = ARGV[5];
	uvalue = ARGV[6];
	uprice = ARGV[7];
	mf_fee_account = ARGV[8];
	mf_fee = ARGV[9];
	xchg_d = getaccount_curr( debit );
	xchg_d = getconv_value( xchg_d );
       	xchg_sym = getaccount_curr( symbol );
        xchg_sym = getconv_value( xchg_sym );
       	xchg_fee = getaccount_curr( mf_fee_account );
        xchg_fee = getconv_value( xchg_fee );
	xchg_debit_sym = xchg_sym / xchg_d;
	xchg_debit_fee = xchg_d / xchg_fee;
	printf("\nDATE: %s %s\n", date, memo);
	printf("[*] %10s %-10s\t%10.3f %s\n", debit, getaccount_name( debit ), uvalue * uprice * xchg_debit_sym, getaccount_curr( debit)); 
	printf("[+] %10s %-10s\t%10.3f %s\n", symbol, getaccount_name( symbol ), uvalue, "SHARE(S)"); 
	printf("[+] %10s %-10s\t%10.3f %s\n", mf_fee_account, getaccount_name( mf_fee_account ), ( mf_fee * xchg_debit_fee ), getaccount_curr( mf_fee_account)); 
	printf("Record transaction -> ");
	getline n < "-";
	if( n == "y" || n == "Y" ){
		rec = transaction_new( "", date, debit, symbol, uvalue, uprice, xchg_debit_sym, memo, transaction_file);
		transaction_new( rec, date, debit, mf_fee_account, mf_fee, 1, xchg_debit_fee, memo, transaction_file);
	}
}

function parse_split(){
	date = ARGV[2];
	memo = ARGV[3];
	debit = ARGV[4];
	credit = ARGV[5];
	uvalue = ARGV[6];
	uprice = 1;
        uprice = 1 / uprice;
	xchg_d = getaccount_curr( debit );
	xchg_d = getconv_value( xchg_d );
       	xchg_c = getaccount_curr( credit );
        xchg_c = getconv_value( xchg_c );
	xchg_rate = xchg_d / xchg_c;
	printf("\nDATE: %s %s\n", date, memo);
	printf("[*] %10s %-10s\t%10.3f %s\n", debit, getaccount_name( debit ), uvalue, getaccount_curr( ARGV[3])); 
	printf("[+] %10s %-10s\t%10.3f %s\n", credit, getaccount_name( credit ), ( uvalue * uprice * xchg_rate ), getaccount_curr( ARGV[4])); 
	for( i = 7; i < ARGC;){
		credit = ARGV[i];
		xchg_c = getaccount_curr( ARGV[i] );
               	xchg_c = getconv_value( ccv_c );
		xchg_rate = xchg_d / xchg_c;
		uvalue = ARGV[i+1];
		printf("[+] %10s %-10s\t%10.3f %s\n", credit, getaccount_name( credit ), uvalue, getaccount_curr( credit ));
		i = i + 2;
	}
	printf("Record transaction -> ");
	getline n < "-";
	if( n == "y" || n == "Y" ) {
    		date = ARGV[2];
		memo = ARGV[3];
		debit = ARGV[4];
		credit = ARGV[5];
		uvalue = ARGV[6];
		uprice = 1;
		xchg_d = getaccount_curr( debit );
               	xchg_d = getconv_value( xchg_d );
               	xchg_c = getaccount_curr( credit );
               	xchg_c = getconv_value( xchg_c );
		xchg_rate = xchg_d / xchg_c;
		recd = transaction_new( "", date, debit, credit, uvalue, 1, xchg_rate, memo, transaction_file );
		for( i = 7; i < ARGC;){
			credit = ARGV[i];
			xchg_c = getaccount_curr( ARGV[i] );
                	xchg_c = getconv_value( ccv_c );
			xchg_rate = xchg_d / xchg_c;
			uvalue = ARGV[i+1];
			transaction_new( recd, date, debit,  credit, uvalue, 1, xchg_rate, memo, transaction_file);
			i = i + 2;
		}
	}
}

function parse_new(){
	date = ARGV[2];
	memo = ARGV[3];
	debit = ARGV[4];
	credit = ARGV[5];
	uvalue = ARGV[6];
	if( uprice == "") uprice = 1;
        uprice = 1 / uprice;
	xchg_d = getaccount_curr( debit );
	xchg_d = getconv_value( xchg_d );
        xchg_c = getaccount_curr( credit );
        xchg_c = getconv_value( xchg_c );
	xchg_rate = xchg_d / xchg_c;
	printf("\nDATE: %-10s %s\n", date, memo);
        printf("[*] %10s\t%-10s\t%10.3f %-6s\t\n", debit, getaccount_name(debit), uvalue, getaccount_curr( debit ));
        printf("[+] %10s\t%-10s\t%10.3f %-6s\t\n", credit, getaccount_name(credit), ( uvalue * uprice * xchg_rate ), getaccount_curr( credit ));
	printf("Record transaction -> ");
	getline n < "-";
	if( n == "y" || n == "Y" ) {
		transaction_new( "", date, debit, credit, uvalue, uprice, xchg_rate, memo, transaction_file );
	}
}

function transaction_new(rec, date, debit, credit, uvalue, uprice, xchg_rate, desc, file){
	getlasttrans(); 
 	if(length(date) < 1) date = last_date;
        if(length(debit) < 1) debit = last_debit;
        if(length(credit) < 1) credit = last_credit;
        if(length(uvalue) < 1) uvalue = last_value;
        if(length(uprice) < 1) uprice = last_price;
        if(rec == "") rec = last_rec + 10;
	
	printf("[ DEBUG ]-> ");
	printf("%-5s\t%-10s\t%6s\t%6s\t%10.3f\t%10.3f\t%6.3f\t%-64s\t\n",rec , date, debit, credit, uvalue, uprice, xchg_rate, desc);
	getline n < "-"
	if( n == "y" || n == "Y")
        printf("%-5s\t%-10s\t%6s\t%6s\t%10.3f\t%10.3f\t%6.3f\t%-64s\t\n",rec , date, debit, credit, uvalue, uprice, xchg_rate, desc) >> file;

	close( file );
	return(rec);
}

function getaccount_name( _accountnum ){
	_account_name = "";
	while((getline < accounts_file)){
		if( $(FACCNUMBER) == _accountnum) {
			_account_name = $(FACCNAME);
			}
		}
	close(accounts_file);
	return _account_name;
}

function getaccount_desc( _accountnum ){
	_account_desc = "";
	while((getline < accounts_file)){
		if( $(FACCNUMBER) == _accountnum) {
			_account_desc = $(FACCDESC);
			}
		}
	close(accounts_file);
	return _account_desc;
}


function getaccount_unit( _accountnum ){
	_unit = "";
	while((getline < accounts_file)){
		if( $(FACCNUMBER) == _accountnum) {
			_unit = $(FUNIT);
			}
	}
	close(accounts_file);
	return _unit;
}


function getaccount_curr( _accountnum ){
	_currency = " ";
	while((getline < accounts_file)){
		if( $(FACCNUMBER) == _accountnum) {
			_currency = $(FCURRENCY);
			}
	}
	close(accounts_file);
	return _currency;
}

function getconv_value( _currency ){
	_ccv = 1;
        if(_currency == CUR_1) _ccv = CV_1;
        if(_currency == CUR_2) _ccv = CV_2;
        return _ccv;
}


function getlasttrans(){
	while((getline < transaction_file)){
	        last_rec = $(FREC);
       		last_date = $(FDATE);
        	last_debit = $(FDEBIT);
        	last_credit = $(FCREDIT);
        	last_value = $(FVALUE);
                last_price = $(FPRC);
		last_ccv = $(FCCV);
        	last_desc = "-";
		}
	close( transaction_file);
}


function debug(){
	print accounts_file;
	print last_date;
}
